### Hierarchy

- Entity
  - ProcessEntity

### Implements

- IEntity
- IProcessEntity

## Index

### Constructors

- constructor

### Properties

- _activeInstances
- _allInstances
- _iamService
- _messageBusService
- _nodeInstanceEntityTypeService
- _processEngineService
- boundProcesses
- context
- entityType
- id
- invoker
- isDirty
- isNew
- propertyBag
- schema
- securityService

### Accessors

- activeInstances
- allInstances
- callerId
- iamService
- isSubProcess
- key
- messageBusService
- name
- nodeInstanceEntityTypeService
- processDef
- processEngineService
- status

### Methods

- _getStartEvent
- addActiveInstance
- calculate
- end
- error
- fromPojo
- getCalculatedProperty
- getDatastoreService
- getEntityReference
- getProcessDef
- getProperty
- getPropertyLazy
- initialize
- initializeProcess
- remove
- removeActiveInstance
- save
- secureCompare
- setCalculatedProperty
- setProperty
- start
- toPojo

## Constructors

### constructor

- new ProcessEntity(iamService: IIamService, nodeInstanceEntityTypeService: INodeInstanceEntityTypeService, messageBusService: IMessageBusService, processEngineService: IProcessEngineService, entityDependencyHelper: EntityDependencyHelper, context: ExecutionContext, schema: IInheritedSchema, propertyBag: IPropertyBag, entityType: IEntityType<IEntity>): ProcessEntity

- Overrides Entity.__constructor

  - Defined in entity_types/process.ts:22

  #### Parameters

  - ##### iamService: IIamService

  - ##### nodeInstanceEntityTypeService: INodeInstanceEntityTypeService

  - ##### messageBusService: IMessageBusService

  - ##### processEngineService: IProcessEngineService

  - ##### entityDependencyHelper: EntityDependencyHelper

  - ##### context: ExecutionContext

  - ##### schema: IInheritedSchema

  - ##### propertyBag: IPropertyBag

  - ##### entityType: IEntityType<IEntity>

  #### Returns ProcessEntity

## Properties

### Private _activeInstances

_activeInstances: any

- Defined in entity_types/process.ts:20

### Private _allInstances

_allInstances: any

- Defined in entity_types/process.ts:21

### Private _iamService

_iamService: IIamService = undefined

- Defined in entity_types/process.ts:15

### Private _messageBusService

_messageBusService: IMessageBusService = undefined

- Defined in entity_types/process.ts:17

### Private _nodeInstanceEntityTypeService

_nodeInstanceEntityTypeService: INodeInstanceEntityTypeService = undefined

- Defined in entity_types/process.ts:16

### Private _processEngineService

_processEngineService: IProcessEngineService = undefined

- Defined in entity_types/process.ts:18

### boundProcesses

boundProcesses: any

- Defined in entity_types/process.ts:22

### context

context: ExecutionContext

Inherited from Entity.context

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:14

### Protected entityType

entityType: IEntityType<IEntity>

Inherited from Entity.entityType

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:17

### id

id: string

Inherited from Entity.id

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:26

### Protected invoker

invoker: IInvoker

Inherited from Entity.invoker

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:16

### isDirty

isDirty: boolean

Inherited from Entity.isDirty

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:22

### isNew

isNew: boolean

Inherited from Entity.isNew

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:21

### Protected propertyBag

propertyBag: IPropertyBag

Inherited from Entity.propertyBag

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:19

### schema

schema: IInheritedSchema

Inherited from Entity.schema

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:15

### Protected securityService

securityService: ISecurityService

Inherited from Entity.securityService

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:18

## Accessors

### activeInstances

- get activeInstances(): any

- - Defined in entity_types/process.ts:61

  #### Returns any

### allInstances

- get allInstances(): any

- - Defined in entity_types/process.ts:65

  #### Returns any

### callerId

- get callerId(): string
- set callerId(value: string): void

- - Defined in entity_types/process.ts:119

  #### Returns string

- - Defined in entity_types/process.ts:123

  #### Parameters

  - ##### value: string

  #### Returns void

### Private iamService

- get iamService(): IIamService

- - Defined in entity_types/process.ts:41

  #### Returns IIamService

### isSubProcess

- get isSubProcess(): boolean
- set isSubProcess(value: boolean): void

- - Defined in entity_types/process.ts:110

  #### Returns boolean

- - Defined in entity_types/process.ts:114

  #### Parameters

  - ##### value: boolean

  #### Returns void

### key

- get key(): string
- set key(value: string): void

- - Defined in entity_types/process.ts:79

  #### Returns string

- - Defined in entity_types/process.ts:83

  #### Parameters

  - ##### value: string

  #### Returns void

### Private messageBusService

- get messageBusService(): IMessageBusService

- - Defined in entity_types/process.ts:49

  #### Returns IMessageBusService

### name

- get name(): string
- set name(value: string): void

- - Defined in entity_types/process.ts:70

  #### Returns string

- - Defined in entity_types/process.ts:74

  #### Parameters

  - ##### value: string

  #### Returns void

### Private nodeInstanceEntityTypeService

- get nodeInstanceEntityTypeService(): INodeInstanceEntityTypeService

- - Defined in entity_types/process.ts:45

  #### Returns INodeInstanceEntityTypeService

### processDef

- get processDef(): IProcessDefEntity
- set processDef(value: IProcessDefEntity): void

- - Defined in entity_types/process.ts:97

  #### Returns IProcessDefEntity

- - Defined in entity_types/process.ts:101

  #### Parameters

  - ##### value: IProcessDefEntity

  #### Returns void

### Private processEngineService

- get processEngineService(): IProcessEngineService

- - Defined in entity_types/process.ts:53

  #### Returns IProcessEngineService

### status

- get status(): string
- set status(value: string): void

- - Defined in entity_types/process.ts:88

  #### Returns string

- - Defined in entity_types/process.ts:92

  #### Parameters

  - ##### value: string

  #### Returns void

## Methods

### Private _getStartEvent

- _getStartEvent(): Promise<INodeDefEntity>

- - Defined in entity_types/process.ts:160

  #### Returns Promise<INodeDefEntity>

### addActiveInstance

- addActiveInstance(entity: IEntity): void

- - Defined in entity_types/process.ts:290

  #### Parameters

  - ##### entity: IEntity

  #### Returns void

### calculate

- calculate(context: ExecutionContext, options?: IFromPojoOptions): Promise<void>

- Inherited from Entity.calculate

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:39

  #### Parameters

  - ##### context: ExecutionContext

  - ##### Optional options: IFromPojoOptions

  #### Returns Promise<void>

### end

- end(context: ExecutionContext, processToken: any): Promise<void>

- - Defined in entity_types/process.ts:234

  #### Parameters

  - ##### context: ExecutionContext

  - ##### processToken: any

  #### Returns Promise<void>

### error

- error(context: ExecutionContext, error: any): Promise<void>

- - Defined in entity_types/process.ts:271

  #### Parameters

  - ##### context: ExecutionContext

  - ##### error: any

  #### Returns Promise<void>

### fromPojo

- fromPojo(context: ExecutionContext, data: any, options?: IFromPojoOptions): Promise<void>

- Inherited from Entity.fromPojo

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:37

  #### Parameters

  - ##### context: ExecutionContext

  - ##### data: any

  - ##### Optional options: IFromPojoOptions

  #### Returns Promise<void>

### getCalculatedProperty

- getCalculatedProperty(propertyThisContext: any, propertyName: string, context: ExecutionContext): Promise<any>

- Inherited from Entity.getCalculatedProperty

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:30

  #### Parameters

  - ##### propertyThisContext: any

  - ##### propertyName: string

  - ##### context: ExecutionContext

  #### Returns Promise<any>

### Protected getDatastoreService

- getDatastoreService(): Promise<IDatastoreService>

- Inherited from Entity.getDatastoreService

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:20

  #### Returns Promise<IDatastoreService>

### getEntityReference

- getEntityReference(): IEntityReference

- Inherited from Entity.getEntityReference

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:56

  #### Returns IEntityReference

### getProcessDef

- getProcessDef(context: ExecutionContext): Promise<IProcessDefEntity>

- - Defined in entity_types/process.ts:105

  #### Parameters

  - ##### context: ExecutionContext

  #### Returns Promise<IProcessDefEntity>

### getProperty

- getProperty(propertyThisContext: any, propertyName: string): any

- Inherited from Entity.getProperty

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:27

  #### Parameters

  - ##### propertyThisContext: any

  - ##### propertyName: string

  #### Returns any

### getPropertyLazy

- getPropertyLazy(propertyThisContext: any, propertyName: string, context: ExecutionContext, options?: IPrivateQueryOptions): Promise<any>

- Inherited from Entity.getPropertyLazy

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:28

  #### Parameters

  - ##### propertyThisContext: any

  - ##### propertyName: string

  - ##### context: ExecutionContext

  - ##### Optional options: IPrivateQueryOptions

  #### Returns Promise<any>

### initialize

- initialize(): Promise<void>

- Overrides Entity.initialize

  - Defined in entity_types/process.ts:57

  #### Returns Promise<void>

### initializeProcess

- initializeProcess(): Promise<void>

- - Defined in entity_types/process.ts:127

  #### Returns Promise<void>

### remove

- remove(context: ExecutionContext, options?: IPrivateRemoveOptions): Promise<boolean>

- Inherited from Entity.remove

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:55

  #### Parameters

  - ##### context: ExecutionContext

  - ##### Optional options: IPrivateRemoveOptions

  #### Returns Promise<boolean>

### removeActiveInstance

- removeActiveInstance(entity: IEntity): void

- - Defined in entity_types/process.ts:295

  #### Parameters

  - ##### entity: IEntity

  #### Returns void

### save

- save(context: ExecutionContext, options?: IPrivateSaveOptions): Promise<IEntity>

- Inherited from Entity.save

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:54

  #### Parameters

  - ##### context: ExecutionContext

  - ##### Optional options: IPrivateSaveOptions

  #### Returns Promise<IEntity>

### secureCompare

- secureCompare(attributeName: string, valueToCompare: string): Promise<boolean>

- Inherited from Entity.secureCompare

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:53

  #### Parameters

  - ##### attributeName: string

  - ##### valueToCompare: string

  #### Returns Promise<boolean>

### setCalculatedProperty

- setCalculatedProperty(propertyThisContext: any, propertyName: string, value: any, context: ExecutionContext): Promise<void>

- Inherited from Entity.setCalculatedProperty

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:31

  #### Parameters

  - ##### propertyThisContext: any

  - ##### propertyName: string

  - ##### value: any

  - ##### context: ExecutionContext

  #### Returns Promise<void>

### setProperty

- setProperty(propertyThisContext: any, propertyName: string, value: any): void

- Inherited from Entity.setProperty

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:29

  #### Parameters

  - ##### propertyThisContext: any

  - ##### propertyName: string

  - ##### value: any

  #### Returns void

### start

- start(context: ExecutionContext, params: IParamStart, options?: IPublicGetOptions): Promise<void>

- - Defined in entity_types/process.ts:171

  #### Parameters

  - ##### context: ExecutionContext

  - ##### params: IParamStart

  - ##### Optional options: IPublicGetOptions

  #### Returns Promise<void>

### toPojo

- toPojo(context: ExecutionContext, options?: IToPojoOptions): Promise<any>

- Inherited from Entity.toPojo

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:32

  #### Parameters

  - ##### context: ExecutionContext

  - ##### Optional options: IToPojoOptions

  #### Returns Promise<any>

Generated using TypeDoc